#!/usr/local/bin/perl

#=====================================================
#                                            GUESTBOOK 4.5
#--------------------------------------------------------------------------------------------
# written by Claude Reuter (22.02.1998)
# Email: claude.reuter@ci.educ.lu
# http://www.restena.lu/primaire/steinsel/steinsel.html
# http://ourworld.compuserve.com/homepages/Reuter_Claude
# http://members.aol.com/members/tempuslux/index.htm
#=====================================================

#====================================================================================================
# Please enter your information here
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
$mailprog = '/usr/lib/sendmail';				#location of the mailprogramm on the server
$getdate = "/bin/date";					#location from where you can get the date on the server 
$guestcgi = "/primaire/steinsel/cgi-bin/gbook4t.cgi";	#location of this script
$recipient = 'claude.reuter@ci.educ.lu';			#your email
$serverurl = 'http://www.restena.lu/primaire/steinsel';	#URL of your server
$directoryurl = 'download/gbook/';			#directory on the server where guestbook files are stored
$book = 'gbookf4.html';					#guestbook-file (chronological order)
$book2 = 'gbookf42.html';				#guestbook-file (alphabetical order)
$home = "http://www.restena.lu/primaire/steinsel/download/download.html";	#location of the homepage
$form = "gbook4.html";					#inscription form
$forbidden = "forbidden.data";				#text-file with the forbidden expressions
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
$whichguestbook = "b";		# enter one of the following letters
				#	a -> guestbook (alphabetical order)
				#	b -> guestbook (alphabetical and chronological order)
				#	c -> guestbook (chronological order) 
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#You have to CHMOD 777 the files $book and $book2
#The files $forbidden and $guestcgi have to be CHMOD 755 
#=====================================================================================================

print "Content-type: text/html\n\n";

$date = `$getdate +"%B %d, %Y"`;
chop($date);

$_ = "../".$directoryurl.$forbidden;
open(NA,"$_") || die "Content-type: text/plain\n\n Could not open $_\n";
@danger=<NA>;
close(NA);
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
if (length($buffer) < 3) {$buffer = $ENV{QUERY_STRING}};
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
foreach $restriction(@danger)
{
chomp($restriction);
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
if ($FORM{$name} =~ /$restriction/i) {&refused};
}
}

if ((length $FORM{'email'} < 5) || ($FORM{'email'} !~ /@/)) {$email = ""} else {$email = $FORM{'email'}};
if ((length $FORM{'homepage'} < 10)  || ($FORM{'homepage'} !~ /http:/)) {$homepage = ""} else {$homepage = $FORM{'homepage'}};
if ($FORM{'action'} eq "submit") {&inscription};

&blank_response unless $FORM{'famname'};
&blank_response unless $FORM{'firstname'};
&blank_response unless $FORM{'sex'};
&blank_response unless $FORM{'age'};
&blank_response unless $FORM{'profession'};
&blank_response unless $FORM{'found'};
&blank_response unless $FORM{'comment'};

&confirmation;
exit;

sub inscription
{
$update = "yes";
if (($whichguestbook eq "b") || ($whichguestbook eq "c")) {
$_ = "../".$directoryurl.$book;
open(BOOK, "$_") || die "Content-type: text/plain\n\n Could not open $_\n";
@contents=<BOOK>;
close(BOOK);
open(BOOK1, ">$_") || die "Content-type: text/plain\n\n Could not open $_\n";
foreach $line (@contents)
{
if (($line =~ /<!--whichguestbook-->/) && ($whichguestbook eq "b")) {
print BOOK1 "<!--whichguestbook-->View the <A HREF=\"$book2\">alphabetical guestbook</A><P>\n";}
else {
if($line =~ /<!--counter-->/) {
($part1,$part2,$part3) = split(/ /,$line);
$part2++;
print BOOK1 "$part1 $part2 $part3";}
else { 
if($line =~ /<!--data-->/) {
print BOOK1 "<!--data-->\n";
print BOOK1 "<DT>$date\n";
print BOOK1 "<DD><B>$FORM{'famname'} $FORM{'firstname'}</B><BR>\n";
print BOOK1 "Sex: $FORM{'sex'}<BR>\n";
print BOOK1 "Profession: $FORM{'profession'}<BR>\n";
print BOOK1 "Age: $FORM{'age'}<BR>\n";
if ($email ne "") {print BOOK1 "Email: <A HREF=\"mailto:$FORM{'email'}\">$FORM{'email'}</A><BR>\n"};
if ($homepage ne "") {print BOOK1 "Homepage: <A HREF=\"$FORM{'homepage'}\" TARGET=\"_new\">$FORM{'homepage'}</A><BR>\n"};
print BOOK1 "Found through: $FORM{'found'}<BR>\n";
print BOOK1 "Comment: $FORM{'comment'}\n";
}
else {
chomp($line);
$bookdate = "<DT>".$date;
if ($line ne $bookdate) {print BOOK1 "$line\n";} else {print BOOK1 "<P>\n";};
}
}
}
}
close (BOOK1);
}

if (($whichguestbook eq "a") || ($whichguestbook eq "b")) {
$_ = "../".$directoryurl.$book2;
open(BOOK2, "$_") || die "Content-type: text/plain\n\n Could not open $_\n";
@contents2=<BOOK2>;
close(BOOK2);
open(BOOK3, ">$_") || die "Content-type: text/plain\n\n Could not open $_\n";
foreach $line2 (@contents2)
{
if (($line2 =~ /<!--whichguestbook-->/) && ($whichguestbook eq "b")) {
print BOOK3 "<!--whichguestbook-->View the <A HREF=\"$book\">chronological guestbook</A><P>\n";}
else {
if ($line2 =~ /<!--counter-->/) {
($part1,$part2,$part3) = split(/ /,$line2);
$part2++;
print BOOK3 "$part1 $part2 $part3";}
else {
if ($update eq "yes") 
{
if ($line2 =~ /<DT>/)
{
$name = $FORM{'famname'}." ".$FORM{'firstname'};
$name = "\L$name";
$name2 = substr($line2,7,length($line2)-5);
$name2 = "\L$name2";}
if (($name lt $name2) || ($line2 =~ /<!--ends data-->/))
{
print BOOK3 "<DT><B>$FORM{'famname'} $FORM{'firstname'}</B>\n";
print BOOK3 "<DD>Sex: $FORM{'sex'}<BR>\n";
print BOOK3 "Profession: $FORM{'profession'}<BR>\n";
print BOOK3 "Age: $FORM{'age'}<BR>\n";
if ($email ne "") {print BOOK3 "Email: <A HREF=\"mailto:$FORM{'email'}\">$FORM{'email'}</A><BR>\n"};
if ($homepage ne "") {print BOOK3 "Homepage: <A HREF=\"$FORM{'homepage'}\" TARGET=\"_new\">$FORM{'homepage'}</A><BR>\n"};
print BOOK3 "Found through: $FORM{'found'}<BR>\n";
print BOOK3 "Comment: $FORM{'comment'}\n";
$update = "no";}
}
print BOOK3 "$line2";}
}
}
close (BOOK3);
}

open (MAIL, "|$mailprog $recipient") || die "Can't open $mailprog!\n";
print MAIL "Subject: CGI-Guestbook45-Test\n";
print MAIL "GUESTBOOK - New entry notification\n";
print MAIL  "\n------------------------------------------------------------\n";
print MAIL "Family Name:		$FORM{'famname'}\n";
print MAIL "First Name:		$FORM{'firstname'}\n";
print MAIL "Sex:			$FORM{'sex'}\n";
print MAIL "Profession:		$FORM{'profession'}\n";
print MAIL "Age:			$FORM{'age'}\n";
if ($email ne "") {print MAIL "Email:			$email\n"}; 
if ($homepage ne "") {print MAIL "Homepage:		$homepage\n"}; 
print MAIL "Found through:	$FORM{'found'}\n";
print MAIL "Comment:		$FORM{'comment'}\n";
print MAIL "\n------------------------------------------------------------\n";
close (MAIL);

&published;
exit;
}

sub blank_response
{
print "<HTML>\n";
print "<META HTTP-EQUIV=\"author\" CONTENT=\"Claude Reuter\">\n";
print "<HEAD><TITLE>Guestbook</Title></HEAD>\n";
print "<!-- Date of last update: 22.02.1998 -->\n";
print "<BODY BGCOLOR=\"#FFFFFF\">\n";
print "<CENTER><H3>Your inscription was uncomplete and will not be send!</H3>\n";
print "The following required fields were empty:<BR>\n";
print "<B>Family Name, </B>\n" unless $FORM{'famname'};
print "<B>First Name, </B>\n" unless $FORM{'firstname'};
print "<B>Age, </B>\n" unless $FORM{'age'};
print "<B>Profession, </B>\n" unless $FORM{'profession'};
print "<B>Found through,</B>\n" unless $FORM{'found'};
print "<B>Comment, </B>\n" unless $FORM{'comment'};
$_ = "../".$directoryurl.$form;
print "<P>Please <A HREF=\"$_\">try it again</A>.</CENTER><P><HR>\n";
$_ = "../".$directoryurl.$book;
if (($whichguestbook eq "b") || ($whichguestbook eq "c"))
{print "View <A HREF=\"$_\">the chronological list of former ESL-students</A>.<BR>\n";}
$_ = "../".$directoryurl.$book2;
if (($whichguestbook eq "a") || ($whichguestbook eq "b"))
{print "View <A HREF=\"$_\">the alphabetical list of former ESL-students</A>.<BR>\n";}
print "<FONT SIZE=-6><I>CGI-Script written by <A HREF=\"mailto:claude.reuter\@ci.educ.lu\">Claude Reuter</A></I></FONT>\n";
print "</BODY></HTML>\n";
exit;
}

sub refused
{
print "<HTML>\n";
print "<META HTTP-EQUIV=\"author\" CONTENT=\"Claude Reuter\">\n";
print "<HEAD><TITLE>Guestbook</Title></HEAD>\n";
print "<!-- Date of last update: 22.02.1998 -->\n";
print "<BODY BGCOLOR=\"#FFFFFF\">\n";
print "<CENTER><H3>Your inscription was refused!</H3>\n";
print "<CENTER><H4>Please don't use HTML-tags!</H4>\n";
$_ = "../".$directoryurl.$form;
print "<P>Please <A HREF=\"$_\">try it again</A>.</CENTER><P><HR>\n";
$_ = "../".$directoryurl.$book;
if (($whichguestbook eq "b") || ($whichguestbook eq "c"))
{print "View <A HREF=\"$_\">the chronological list of former ESL-students</A>.<BR>\n";}
$_ = "../".$directoryurl.$book2;
if (($whichguestbook eq "a") || ($whichguestbook eq "b"))
{print "View <A HREF=\"$_\">the alphabetical list of former ESL-students</A>.<BR>\n";}
print "<FONT SIZE=-6><I>CGI-Script written by <A HREF=\"mailto:claude.reuter\@ci.educ.lu\">Claude Reuter</A></I></FONT>\n";
print "</BODY></HTML>\n";
exit;
}

sub confirmation
{
print "<HTML>\n";
print "<META HTTP-EQUIV=\"author\" CONTENT=\"Claude Reuter\">\n";
print "<HEAD><TITLE>Guestbook</Title></HEAD>\n";
print "<!-- Date of last update: 22.02.1998 -->\n";
print "<BODY BGCOLOR=\"#FFFFFF\">\n";
print "<CENTER><H3>Thanks for your inscription!</H3>\n";
print "You have entered the following text to be published in the guest-book:<P>\n";
print "<TABLE BORDER=1><TR><TD>\n";
print "<TABLE BORDER=0>\n";
print "<TR><TD>Family Name</TD><TD>$FORM{'famname'}</TD></TR>\n";
print "<TR><TD>First name</TD><TD>$FORM{'firstname'}</TD></TR>\n";
print "<TR><TD>Sex</TD><TD>$FORM{'sex'}</TD></TR>\n";
print "<TR><TD>Profession</TD><TD>$FORM{'profession'}</TD></TR>\n";
print "<TR><TD>Age</TD><TD>$FORM{'age'}</TD></TR>\n";
if ($email ne "") {print "<TR><TD>Email</TD><TD><A HREF=\"mailto:$FORM{'email'}\">$FORM{'email'}</A></TD></TR>\n"};
if ($homepage ne "") {print "<TR><TD>Homepage</TD><TD><A HREF=\"$FORM{'homepage'}\">$FORM{'homepage'}</TD>\n"};
print "<TR><TD>Found through</TD><TD>$FORM{'found'}</TD></TR>\n";
print "<TR><TD>Comment</TD><TD>$FORM{'comment'}</TD></TR>\n";
print "</TR></TABLE></TD></TR></TABLE><P>\n";
foreach $key (keys %FORM) {
$FORM{$key} =~ tr/ /+/;
};
print "<FORM ACTION=\"$guestcgi?famname=$FORM{'famname'}&firstname=$FORM{'firstname'}&sex=$FORM{'sex'}&profession=$FORM{'profession'}&age=$FORM{'age'}&email=$FORM{'email'}&homepage=$FORM{'homepage'}&found=$FORM{'found'}&comment=$FORM{'comment'}&action=submit\" METHOD=POST>\n";
print "<INPUT  TYPE=\"SUBMIT\" VALUE=\"Submit Data\"></FORM>\n";
print "<B>To do changes to your data, please click on the Back button of your browser!</B></CENTER><P><HR>\n";
$_ = "../".$directoryurl.$book;
if (($whichguestbook eq "b") || ($whichguestbook eq "c"))
{print "View <A HREF=\"$_\">the chronological list of former ESL-students</A>.<BR>\n";}
$_ = "../".$directoryurl.$book2;
if (($whichguestbook eq "a") || ($whichguestbook eq "b"))
{print "View <A HREF=\"$_\">the alphabetical list of former ESL-students</A>.<BR>\n";}
print "<A HREF=\"$home\" TARGET=\"_top\">Back</A><HR>\n";
print "<FONT SIZE=-6><I>CGI-Script written by <A HREF=\"mailto:claude.reuter\@ci.educ.lu\">Claude Reuter</A></I></FONT>\n";
print "</BODY></HTML>\n";
exit;
}

sub published
{
if ($whichguestbook eq "a") {$_ = "../".$directoryurl.$book2;}
else {$_ = "../".$directoryurl.$book;}
print "<HTML>\n";
print "<META HTTP-EQUIV=\"refresh\" CONTENT=\"1;URL=$_\">\n";
print "<META HTTP-EQUIV=\"author\" CONTENT=\"Claude Reuter\">\n";
print "<HEAD><TITLE>Guestbook</Title></HEAD>\n";
print "<!-- Date of last update: 22.02.1998 -->\n";
print "<BODY BGCOLOR=\"#FFFFFF\">\n";
print "<CENTER><H3>Your text is now published in the guestbook!<P>\n";
print "You will be redirected to the guestbook to view your entry.<BR>If this page remains longer than 5 seconds, please use the above link.</H3>\n";
print "<FONT COLOR=\"#FF0000\"><STRONG>Don't forget to reload the guestbook!</STRONG></FONT></CENTER><P><HR>\n";
$_ = "../".$directoryurl.$book;
if (($whichguestbook eq "b") || ($whichguestbook eq "c"))
{print "View <A HREF=\"$_\">the chronological list of former ESL-students</A>.<BR>\n";}
$_ = "../".$directoryurl.$book2;
if (($whichguestbook eq "a") || ($whichguestbook eq "b"))
{print "View <A HREF=\"$_\">the alphabetical list of former ESL-students</A>.<BR>\n";}
print "<A HREF=\"$home\" TARGET=\"_top\">Back</A><HR>\n";
print "<FONT SIZE=-6><I>CGI-Script written by <A HREF=\"mailto:claude.reuter\@ci.educ.lu\">Claude Reuter</A></I></FONT>\n";
print "</BODY></HTML>\n";
}